//---------------------------------------------------------------------------------------------
// Torque Game Builder
// Copyright (C) GarageGames.com, Inc.
//---------------------------------------------------------------------------------------------

//---------------------------------------------------------------------------------------------
// initializeProject
// Perform game initialization here.
//---------------------------------------------------------------------------------------------
//$pref::T2D::imageMapDumpTextures = 1;
//$pref::T2D::imageMapShowPacking = 1;

//$Game::editing = 1;

function initializeProject()
{
   //Audio Datas
   exec("./data/audio/audioDatablocks.cs");
   
   exec("./gameScripts/newProfiles.cs");
   exec("./preferences/gamePrefs.cs");

   // Load up the in game gui. newsLetterGui.gui
   exec("~/gui/mainScreen.gui");
   exec("~/gui/mainScreenGui.gui");
   exec("~/gui/LevelFinishGui.gui");
   exec("~/gui/LevelFadeGui.gui");
   exec("~/gui/InGameOptionsGui.gui");
   exec("~/gui/MapGui.gui");
   exec("~/gui/mainMenuGui.gui");
   //exec("~/gui/optionsDlg.gui");
   //exec("~/gui/optionsDlg.cs");
   exec("~/gui/options.gui");
   exec("~/gui/ExitGameGui.gui");
   exec("~/gui/SaveGui.gui");
   exec("~/gui/LoadGui.gui");
   exec("~/gui/CreatePlayerGui.gui");
   exec("~/gui/DeletePlayerGui.gui");
   exec("~/gui/NameExistedGui.gui");
   exec("~/gui/LevelStartGui.gui");
   exec("~/gui/StartupGui.gui");
   exec("~/gui/GGLogoGui.gui");
   exec("~/gui/UpgradesDlg.gui");
   exec("~/gui/HowToPlayPage00Gui.gui");
   exec("~/gui/tutStartDialogGui.gui");
   exec("~/gui/MapInfoTutGui.gui");
   exec("~/gui/MapInfoGui.gui");
   exec("~/gui/WinGameGui.gui");
   exec("~/gui/CreditsDlg.gui");
   exec("~/gui/DemoQuitGui.gui");
   exec("~/gui/timeOverGui.gui");
   exec("~/gui/newsLetterGui.gui");
   //exec("~/gui/StartupGui.gui");
   

   
   // Exec game scripts.           puss.cs
   exec("./gameScripts/game.cs");
   exec("./gameScripts/inputHandler.cs");
   exec("./gameScripts/player.cs");
   exec("./gameScripts/weapons.cs");
   exec("./gameScripts/playerMissile.cs");
   exec("./gameScripts/enemy.cs");
   exec("./gameScripts/statesEnemy.cs");
   exec("./gameScripts/statesControlledUnit.cs");
   exec("./gameScripts/statesPlayer.cs");
   exec("./gameScripts/statesCustomer.cs");
   exec("./gameScripts/common.cs");
   exec("./gameScripts/level.cs");
   exec("./gameScripts/spawner.cs");
   exec("./gameScripts/array.cs");
   exec("./gameScripts/killDecal.cs");
   exec("./gameScripts/items.cs");
   exec("./gameScripts/bulletTracer.cs");
   exec("./gameScripts/simplePathSearch.cs");
   exec("./gameScripts/table.cs");
   exec("./gameScripts/customer.cs");
   exec("./gameScripts/stackedMoves.cs");
   exec("./gameScripts/orderFoodIcon.cs");
   exec("./gameScripts/scores.cs");
   exec("./gameScripts/savingLoading.cs");
   exec("./gameScripts/manda.cs");
   exec("./gameScripts/puss.cs");
   exec("./gameScripts/tcp.cs");


   createUpgradeData();
   //$defaultGame = "ForestFiesta";
   $runWithEditors = false;
   // Remove the following four lines if you would likae to start the game without running the
   // level builder.
   if ($runWithEditors)
   {
      toggleLevelEditor();
      return;
   }else{
       LBPlayWindowCtrlStack.setVisible(0);
       
       loadGGStartup();

       return;
       Canvas.setContent(MainMenuGui);
       mainMenuSceneWindow2D.loadLevel("ForestFiesta/data/levels/MainMenu.t2d");
       //Canvas.pushDialog(MainMenuGui);
       //mainMenuSceneWindow2D
       //startGame("ForestFiesta/data/levels/MainMenu.t2d");
   }
   
   // This is where the game starts. Right now, we are just starting the first level. You will
   // want to expand this to load up a splash screen followed by a main menu depending on the
   // specific needs of your game. Most likely, a menu button will start the actual game, which
   // is where startGame should be called from.

   updateEditingGui();
   

}

//---------------------------------------------------------------------------------------------
// shutdownProject
// Clean up your game objects here.
//---------------------------------------------------------------------------------------------
function shutdownProject()
{
   endGame();
}

//---------------------------------------------------------------------------------------------
// setupKeybinds
// Bind keys to actions here..
//---------------------------------------------------------------------------------------------
function setupKeybinds()
{
   new ActionMap(moveMap);
   //moveMap.bind("keyboard", "a", "doAction", "Action Description");
}

//0.11876 -0.37694 0.23580 -0.31497 0.32186 0.93804 -0.29776 0.93115 -0.16695 0.34251

//---------------------------------------------------------------------------------------------
// onExit
// Called when the engine is shutting down. Shutdowns this mod.
//---------------------------------------------------------------------------------------------
function onExit()
{
   echo("Exporting Game specific preferences.");
   export("$GamePref::*", "./preferences/gamePrefs.cs", false);

   // Shutdown stuff.
   //shutdownCommon();

   Parent::onExit();
}

function windowFocusChanged(%active){
    echo("windowFocusChanged" SPC %active);
    
    $game::windowFocused = %active;
    if($Game::started == 1 && %active == 0 && $timeScale != 0 && $Game::lvlFinished == 0){
        Canvas.pushDialog(InGameOptionsGui);
    }
}

//=====================================================
//Editing Here
function updateEditingGui(){
    if($Game::editing){
        gameInfoText.setVisible(1);
        DeugMenu.setVisible(1);
    }else{
        gameInfoText.setVisible(0);
        DeugMenu.setVisible(0);
    }
}
